<?php
/**
* @version $Id: admin.content.php,v 1.36 2004/09/06 12:06:21 eddieajau Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'admin_html' ) );

$sectionid = mosGetParam( $_REQUEST, 'sectionid', 0 );
$cid = mosGetParam( $_POST, 'cid', array(0) );
if (!is_array( $cid )) {
	$cid = array(0);
}

switch ($task) {
	case "clean_cache":
		mosCache::cleanCache( 'com_content' );
		mosRedirect( 'index2.php', 'Cache cleaned' );
		break;
	case "new":
		editContent( 0, $sectionid, $option );
		break;
	case "edit":
		editContent( $cid[0], '', $option );
		break;
	case "save":
		mosCache::cleanCache( 'com_content' );
		saveContent( $sectionid, $option );
		break;
	case "remove":
		removeContent( $cid, $sectionid, $option );
		break;
	case "publish":
		changeContent( $cid, 1, $sectionid, $option );
		break;
	case "unpublish":
		changeContent( $cid, 0, $sectionid, $option );
		break;
	case "toggle_frontpage":
		toggleFrontPage( $cid, $sectionid, $option );
		break;
	case "archive":
		changeContent( $cid, -1, $sectionid, $option );
		break;
	case "unarchive":
		changeContent( $cid, 0, $sectionid, $option );
		break;
	case "cancel":
		cancelContent( $option );
		break;
	case "orderup":
		orderContent( $cid[0], -1, $option );
		break;
	case "orderdown":
		orderContent( $cid[0], 1, $option );
		break;
	case "showarchive":
		viewArchive( $sectionid, $option );
		break;
	case "movesect":
		moveSection( $cid, $sectionid, $option );
		break;
	case "movesectsave":
		moveSectionSave( $cid, $sectionid, $option );
		break;
	case "copy":
		copyItem( $cid, $sectionid, $option );
		break;
	case "copysave":
		copyItemSave( $cid, $sectionid, $option );
		break;
	case "resethits":
		resetHits();
		saveContent( $sectionid, $option );
		break;
	case "accesspublic":
		accessMenu( $cid[0], 0, $option, $client );
		break;
	case "accessregistered":
		accessMenu( $cid[0], 1, $option, $client );
		break;
	case "accessspecial":
		accessMenu( $cid[0], 2, $option, $client );
		break;
	default:
		viewContent( $sectionid, $option );
		break;
}

/**
* Compiles a list of installed or defined modules
* @param database A database connector object
*/
function viewContent( $sectionid, $option ) {
	global $database, $mainframe, $mosConfig_list_limit;

	$catid = $mainframe->getUserStateFromRequest( "catid{$option}{$sectionid}", 'catid', 0 );
	$filter_sectionid = $mainframe->getUserStateFromRequest( "filter_sectionid{$option}{$sectionid}", 'filter_sectionid', 0 );
	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}{$sectionid}limitstart", 'limitstart', 0 );
	$search = $mainframe->getUserStateFromRequest( "search{$option}{$sectionid}", 'search', '' );
	$search = $database->getEscaped( trim( strtolower( $search ) ) );
	$redirect = $sectionid;
	$filter = ''; //getting a undefined variable error

	if ( $sectionid == 0 ) {
		// used to show All content items
		$where = array(
		"c.state >= 0",
		"c.catid=cc.id",
		"cc.section=s.id",
		"s.scope='content'",
		);
		$order = "\n ORDER BY s.title, c.catid, cc.ordering, cc.title, c.ordering";
		$all = 1;
		//$filter = "\n , #__sections AS s WHERE s.id = c.section";
		
		if ($filter_sectionid > 0) {
		    $filter = "\nWHERE c.section=$filter_sectionid";
		}
		$section->title = 'All Content Items';
		$section->id = 0;
	} else {
		$where = array(
		"c.state >= 0",
		"c.catid=cc.id",
		"cc.section=s.id",
		"s.scope='content'",
		"c.sectionid='$sectionid'"
		);
		$order = "\n ORDER BY cc.ordering, cc.title, c.ordering";
		$all = NULL;
		$filter = "\n WHERE cc.section = '$sectionid'";
		$section = new mosSection( $database );
		$section->load( $sectionid );	
	}

	// used by filter
	if ( $filter_sectionid > 0 ) {
		$where[] = "c.sectionid = '$filter_sectionid'";
	}
	if ( $catid > 0 ) {
		$where[] = "c.catid='$catid'";
	}

	if ( $search ) {
		$where[] = "LOWER( c.title ) LIKE '%$search%'";
	}

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__content AS c, #__categories AS cc, #__sections AS s"
	. (count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : "")
	);
	$total = $database->loadResult();
	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	$query = "SELECT c.*, g.name AS groupname, cc.name, u.name AS editor, f.content_id AS frontpage, s.title AS section_name"
	. "\n FROM #__content AS c, #__categories AS cc, #__sections AS s"
	. "\n LEFT JOIN #__groups AS g ON g.id = c.access"
	. "\n LEFT JOIN #__users AS u ON u.id = c.checked_out"
	. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = c.id"
	. ( count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : '' )
	. $order
	. "\n LIMIT $pageNav->limitstart,$pageNav->limit"
	;
	$database->setQuery( $query );
	$rows = $database->loadObjectList();

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// get list of categories for dropdown filter
	$categories[] = mosHTML::makeOption( '0', 'All Categories' );
	$query = "SELECT cc.id AS value, CONCAT_WS( '::', s.title, cc.title) AS text, section"
	. "\n FROM #__categories AS cc"
	. "\nINNER JOIN #__sections AS s ON s.id=cc.section "
	. $filter
	. "\n ORDER BY s.ordering, cc.ordering"
	;

	$database->setQuery( $query );
	$categories = array_merge( $categories, $database->loadObjectList() );
	$lists = array();
	$lists['catid'] = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid );
	// get list of sections for dropdown filter
	$sections[] = mosHTML::makeOption( '0', 'All Sections' );
	$query = "SELECT s.id AS value, s.title AS text"
	. "\n FROM #__sections AS s"
	. "\n ORDER BY s.ordering"
	;
	$database->setQuery( $query );
	$sections = array_merge( $sections, $database->loadObjectList() );
	$lists['sectionid'] = mosHTML::selectList( $sections, 'filter_sectionid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $filter_sectionid );

	HTML_content::showContent( $rows, $section, $lists, $search, $pageNav, $option, $all, $redirect );
}

/**
* Shows a list of archived content items
* @param int The section id
*/
function viewArchive( $sectionid, $option ) {
	global $database, $mainframe, $mosConfig_list_limit;

	$catid = $mainframe->getUserStateFromRequest( "catidarc{$option}{$sectionid}", 'catid', 0 );
	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit );
	$limitstart = $mainframe->getUserStateFromRequest( "viewarc{$option}{$sectionid}limitstart", 'limitstart', 0 );
	$search = $mainframe->getUserStateFromRequest( "searcharc{$option}{$sectionid}", 'search', '' );
	$filter_sectionid = $mainframe->getUserStateFromRequest( "filter_sectionid{$option}{$sectionid}", 'filter_sectionid', 0 );
	$search = $database->getEscaped( trim( strtolower( $search ) ) );
	$redirect = $sectionid;

	if ( $sectionid == 0 ) {
		$where = array(
		"c.state = -1",
		"c.catid=cc.id",
		"cc.section=s.id",
		"s.scope='content'"
		);
		$filter = "\n , #__sections AS s WHERE s.id = c.section";
		$all = 1;
	} else {
		$where = array(
		"c.state = -1",
		"c.catid=cc.id",
		"cc.section=s.id",
		"s.scope='content'",
		"c.sectionid='$sectionid'"
		);
		$filter = "\n WHERE section = '$sectionid'";
		$all = NULL;
	}

	// used by filter
	if ( $filter_sectionid > 0 ) {
		$where[] = "c.sectionid = '$filter_sectionid'";
	}
	if ($catid > 0) {
		$where[] = "c.catid='$catid'";
	}
	if ($search) {
		$where[] = "LOWER(c.title) LIKE '%$search%'";
	}

	// get the total number of records
	$query = "SELECT count(*)"
	. "FROM #__content AS c, #__categories AS cc, #__sections AS s"
	. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : '' )
	;
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );

	$query = "SELECT c.*, g.name AS groupname, cc.name"
	. "\n FROM #__content AS c, #__categories AS cc, #__sections AS s"
	. "\n LEFT JOIN #__groups AS g ON g.id = c.access"
	. ( count( $where ) ? "\nWHERE " . implode( ' AND ', $where ) : '' )
	. "\n ORDER BY c.catid, c.ordering"
	. "\n LIMIT $pageNav->limitstart,$pageNav->limit"
	;
	$database->setQuery( $query );

	$rows = $database->loadObjectList();
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	$lists = array();
	// get list of categories for dropdown filter
	$categories[] = mosHTML::makeOption( '0', 'All Categories' );
	$query = "SELECT c.id AS value, c.title AS text"
	. "\n FROM #__categories AS c"
	. $filter
	. "\n ORDER BY c.ordering"
	;
	$database->setQuery( $query );
	$categories = array_merge( $categories, $database->loadObjectList() );
	$lists = array();
	$lists['catid'] = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $catid );
	// get list of sections for dropdown filter
	$sections[] = mosHTML::makeOption( '0', 'All Sections' );
	$query = "SELECT s.id AS value, s.title AS text"
	. "\n FROM #__sections AS s"
	. "\n ORDER BY s.ordering"
	;
	$database->setQuery( $query );
	$sections = array_merge( $sections, $database->loadObjectList() );
	$lists['sectionid'] = mosHTML::selectList( $sections, 'filter_sectionid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $filter_sectionid );

	$section = new mosSection( $database );
	$section->load( $sectionid );

	HTML_content::showArchive( $rows, $section, $lists, $search, $pageNav, $option, $all, $redirect );
}

/**
* Compiles information to add or edit the record
* @param database A database connector object
* @param integer The unique id of the record to edit (0 if new)
* @param integer The id of the content section
*/
function editContent( $uid=0, $sectionid=0, $option ) {
	global $database, $my, $mainframe;
	global $mosConfig_absolute_path, $mosConfig_live_site;

	$row = new mosContent( $database );
	// load the row from the db table
	$row->load( $uid );

	if ($uid) {
		$sectionid = $row->sectionid;
		if ($row->state < 0) {
			mosRedirect( 'index2.php?option=com_content&sectionid='. $row->sectionid, 'You cannot edit an archived item' );
		}
	}
	
	$redirect = mosGetParam( $_POST, 'redirect', $sectionid );

	if ( $sectionid == 0 ) {
		$where = "\n WHERE section NOT LIKE '%com_%'";
	} else {
		$where = "\n WHERE section='$sectionid'";
	}

	$lists = array();

	// get the type name - which is a special category
	 if ($row->sectionid){
		$database->setQuery( "SELECT name FROM #__sections WHERE id=$row->sectionid" );
		$section = $database->loadResult();
	} else {
		$database->setQuery( "SELECT name FROM #__sections WHERE id=$sectionid" );
		$section = $database->loadResult();
	}

	// fail if checked out not by 'me'
	if ($row->checked_out && $row->checked_out <> $my->id) {
		mosRedirect( 'index2.php?option=com_content', 'The module '. $row->title .' is currently being edited by another administrator' );
	}

	if ($uid) {
		$row->checkout( $my->id );
		if (trim( $row->images )) {
			$row->images = explode( "\n", $row->images );
		} else {
			$row->images = array();
		}
		if (trim( $row->publish_down ) == '0000-00-00 00:00:00') {
			$row->publish_down = 'Never';
		}
	} else {
		$row->sectionid = $sectionid;
		$row->version = 0;
		$row->state = 1;
		$row->ordering = 9999;
		$row->images = array();
		$row->publish_up = date( 'Y-m-d', time() );
		$row->publish_down = 'Never';
		$row->catid = NULL;
	}

	// get list of images
	$imgFiles = mosReadDirectory( $mosConfig_absolute_path .'/images/stories' );
	$images = array();
	$folders = array();
	$folders[] = mosHTML::makeOption( '/' );
	_readImages( $mosConfig_absolute_path .'/images/stories', '/', $folders, $images );

	if ( ! isset($images['/']) ) {
		$images['/'][] = mosHTML::makeOption( '' );
	}

	$lists['imagefiles'] = mosHTML::selectList( $images['/'], 'imagefiles', "class=\"inputbox\" size=\"10\" multiple=\"multiple\""
	. " onchange=\"previewImage('imagefiles','view_imagefiles','$mosConfig_live_site/images/stories/')\"",
	'value', 'text', null );

	$lists['folders'] = mosHTML::selectList( $folders, 'folders', "class=\"inputbox\" size=\"1\" "
	."onchange=\"changeDynaList('imagefiles',folderimages,document.adminForm.folders.options[document.adminForm.folders.selectedIndex].value, 0, 0);  previewImage('imagefiles','view_imagefiles','$mosConfig_absolute_path/images/stories/');\"",
	'value', 'text', '/' );

	// make the list of saved images
	$images2 = array();
	foreach ($row->images as $file) {
		$temp = explode( '|', $file );
		if( strrchr($temp[0], '/') ) {
			$filename = substr( strrchr($temp[0], '/'), 1 );
		} else {
			$filename = $temp[0];
		}

		$images2[] = mosHTML::makeOption( $file, $filename );
	}

	$lists['imagelist'] = mosHTML::selectList( $images2, 'imagelist', "class=\"inputbox\" size=\"10\""
	. " onchange=\"showImageProps('$mosConfig_live_site/images/stories/')\"",
	'value', 'text', null );

	// make the select list for the image positions
	$pos[] = mosHTML::makeOption( '', _CMN_NONE );
	$pos[] = mosHTML::makeOption( 'left', _CMN_LEFT );
	$pos[] = mosHTML::makeOption( 'center', _CMN_CENTER );
	$pos[] = mosHTML::makeOption( 'right', _CMN_RIGHT );

	// build the html select list
	$lists['_align'] = mosHTML::selectList( $pos, '_align', 'class="inputbox" size="4"', 'value', 'text', null );

	// get list of groups
	$database->setQuery( "SELECT id AS value, name AS text FROM #__groups ORDER BY id" );
	$groups = $database->loadObjectList();

	// build the html select list
	$lists['access'] = mosHTML::selectList( $groups, 'access', 'class="inputbox" size="1"', 'value', 'text', intval( $row->access ) );

	// get list of other menu items by order

	if ($uid) {
		// build the html select list for ordering
		$query = "SELECT ordering AS value, title AS text"
		. "\n FROM #__content"
		. "\n WHERE catid='$row->catid'" 
		. "\n AND state >= 0"
		. "\n ORDER BY ordering"
		;
		$order = mosGetOrderingList( $query );
		$lists['ordering'] = mosHTML::selectList( $order, 'ordering', 'class="inputbox" size="1"', 'value', 'text', intval( $row->ordering ) );
	} else {
		$lists['ordering'] = '<input type="hidden" name="ordering" value="'. $row->ordering .'" />New items default to the last place';
	}

	if ($uid) {
		$query = "SELECT name from #__users"
		. "\n WHERE id=$row->created_by"
		;
		$database->setQuery( $query );
		$row->creator = $database->loadResult();

		$query = "SELECT name from #__users"
		. "\n WHERE id=$row->modified_by"
		;
		$database->setQuery( $query );
		$row->modifier = $database->loadResult();

		$query = "SELECT content_id from #__content_frontpage"
		. "\n WHERE content_id=$row->id"
		;
		$database->setQuery( $query );
		$row->frontpage = $database->loadResult();
	} else {
		$row->creator = '';
		$row->modifier = '';
		$row->frontpage = 0;
	}

	// get list of users
	$query = "SELECT id AS value, name AS text"
	. "\n FROM #__users"
	. "\n ORDER BY name"
	;
	$database->setQuery( $query );
	$users = $database->loadObjectList();
	$lists['created_by'] = mosHTML::selectList( $users, 'created_by', 'class="inputbox" size="1"', 'value', 'text', intval( $row->created_by ) ? intval( $row->created_by ) : $my->id);

	if ( !$row->catid ) {
		// get list of categories
		$categories[] = mosHTML::makeOption( '-1', 'Select Category' );
		$query = "SELECT id AS value, name AS text"
		. "\n FROM #__categories"
		. $where
		. "\n ORDER BY ordering"
		;
		$database->setQuery( $query );
		$categories = array_merge( $categories, $database->loadObjectList() );
		if (count( $categories ) < 2) {
			mosRedirect( 'index2.php?option=com_categories&section='. $sectionid, 'You must add a category for this section first.' );
		}
		//cat_select = 'onchange="changeDynaList(\'ordering\',orders,document.adminForm.position.options[document.adminForm.position.selectedIndex].value, originalPos, originalOrder)"';
		$lists['catid'] = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1"', 'value', 'text', intval( $row->catid ) );
	} else {
		$categories = new mosCategory( $database );
		$categories->load( $row->catid );
		$lists['catid'] = '<input type="hidden" name="catid" value="'. $row->catid .'" />'. $categories->title;
	}

	if ( $sectionid == 0 ) {
		$sections[] = mosHTML::makeOption( '-1', 'Select Section' );
		$query = "SELECT s.id AS value, s.title AS text"
		. "\n FROM #__sections AS s"
		. "\n ORDER BY s.ordering"
		;
		$database->setQuery( $query );
		$sections = array_merge( $sections, $database->loadObjectList() );
		$lists['sectionid'] = mosHTML::selectList( $sections, 'sectionid', 'class="inputbox" size="1"', 'value', 'text' );
	} else {
		$temp = new mosSection( $database );
		$temp->load( $row->sectionid );
		$section_name = $temp->title;
		$lists['sectionid'] = '<input type="hidden" name="sectionid" value="'. $row->sectionid .'" />'. $section_name;
	}

	// get params definitions
	$params =& new mosParameters( $row->attribs,	$mainframe->getPath( 'com_xml', 'com_content' ), 'component' );

	HTML_content::editContent( $row, $section, $lists, $images, $my->id, $params, $option, $categories, $redirect );
}

/**
* Saves the content item an edit form submit
* @param database A database connector object
*/
function saveContent( $sectionid, $option ) {
	global $database, $my, $mainframe;

	$redirect = mosGetParam( $_POST, 'redirect', $row->sectionid );

	$row = new mosContent( $database );
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$isNew = ($row->id < 1);
	if ($isNew) {
		$row->created = $row->created ? $row->created : date( "Y-m-d H:i:s" );
		$row->created_by = $row->created_by ? $row->created_by : $my->id;
	} else {
		$row->modified = date( "Y-m-d H:i:s" );
		$row->modified_by = $my->id;
		$row->created = $row->created ? $row->created : date( "Y-m-d H:i:s" );
		$row->created_by = $row->created_by ? $row->created_by : $my->id;
	}
	if (trim( $row->publish_down ) == "Never") {
		$row->publish_down = "0000-00-00 00:00:00";
	}

	$row->mask = 0;
	$row->mask |= intval( mosGetParam( $_POST, 'mask_hide_title', 0 ) );
	echo intval( $row->mask );

	$row->state = mosGetParam( $_REQUEST, 'published', 0 );

	$params = mosGetParam( $_POST, 'params', '' );
	if (is_array( $params )) {
		$txt = array();
		foreach ( $params as $k=>$v) {
			$txt[] = "$k=$v";
		}
		$row->attribs = implode( "\n", $txt );
	}

	// code cleaner for xhtml transitional compliance
	$row->introtext = str_replace( "<br>", "<br/>", $row->introtext );
	$row->fulltext = str_replace( "<br>", "<br/>", $row->fulltext );

	if (!$row->check()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->version++;
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$msg = '';


	// manage frontpage items

	require_once( $mainframe->getPath( 'class', 'com_frontpage' ) );
	$fp = new mosFrontPage( $database );

	if (mosGetParam( $_REQUEST, 'frontpage', 0 )) {

		// toggles go to first place
		if (!$fp->load( $row->id )) {
			// new entry
			$database->setQuery( "INSERT INTO #__content_frontpage VALUES ('$row->id','1')" );
			if (!$database->query()) {
				echo "<script> alert('".$database->stderr()."');</script>\n";
				exit();
			}
			$fp->ordering = 1;
		}
	} else {
		// no frontpage mask
		if (!$fp->delete( $row->id )) {
			$msg .= $fp->stderr();
		}
		$fp->ordering = 0;
	}
	$fp->updateOrder();

	$row->checkin();
	$row->updateOrder( "catid='$row->catid' AND state >= 0" );

	mosRedirect( 'index2.php?option=com_content&sectionid='. $redirect .'&msg='. $msg );
}

/**
* Changes the state of one or more content pages
* @param string The name of the category section
* @param integer A unique category id (passed from an edit form)
* @param array An array of unique category id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the current user
*/
function changeContent( $cid=null, $state=0, $section, $option ) {
	global $database;

	if (count( $cid ) < 1) {
		$action = $publish == 1 ? 'publish' : ($publish == -1 ? 'archive' : 'unpublish');
		echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$total = count ( $cid );
	$cids = implode( ',', $cid );

	$database->setQuery( "UPDATE #__content SET state='$state'"
	. "\nWHERE id IN ($cids) AND (checked_out=0 OR (checked_out='$my->id'))"
	);
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new mosContent( $database );
		$row->checkin( $cid[0] );
	}

	if ( $state == "-1" ) {
		$msg = $total ." Item(s) successfully Archived";
	} else if ( $state == "1" ) {
		$msg = $total ." Item(s) successfully Published";
	} else if ( $state == "0" ) {
		$msg = $total ." Item(s) successfully Unpublished";
	}

	$redirect = mosGetParam( $_POST, 'redirect', $row->sectionid );
	$task = mosGetParam( $_POST, 'returntask', '' );
	if ( $task ) {
		$task = '&task='. $task;
	} else {
		$task = '';
	}

	mosRedirect( 'index2.php?option='. $option . $task .'&sectionid='. $redirect .'&mosmsg='. $msg );
}

/**
* Changes the state of one or more content pages
* @param string The name of the category section
* @param integer A unique category id (passed from an edit form)
* @param array An array of unique category id numbers
* @param integer 0 if unpublishing, 1 if publishing
* @param string The name of the current user
*/
function toggleFrontPage( $cid, $section, $option ) {
	global $database, $my, $mainframe;

	if (count( $cid ) < 1) {
		echo "<script> alert('Select an item to toggle'); window.history.go(-1);</script>\n";
		exit;
	}

	$msg = '';
	require_once( $mainframe->getPath( 'class', 'com_frontpage' ) );

	$fp = new mosFrontPage( $database );
	foreach ($cid as $id) {
		// toggles go to first place
		if ($fp->load( $id )) {
			if (!$fp->delete( $id )) {
				$msg .= $fp->stderr();
			}
			$fp->ordering = 0;
		} else {
			// new entry
			$database->setQuery( "INSERT INTO #__content_frontpage VALUES ('$id','1')" );
			if (!$database->query()) {
				echo "<script> alert('".$database->stderr()."');</script>\n";
				exit();
			}
			$fp->ordering = 1;
		}
		$fp->updateOrder();
	}

	mosRedirect( "index2.php?option=$option&sectionid=$section", $msg );
}

function removeContent( &$cid, $sectionid, $option ) {
	global $database, $mainframe;

	$total = count( $cid );
	if ( $total < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}

	$state = '-2';
	$ordering = '0';
	//seperate contentids
	$cids = implode( ',', $cid );
	$query = 	"UPDATE #__content SET state = '". $state ."', ordering = '". $ordering ."'"
	. "\n WHERE id IN ( ". $cids ." )"
	;
	$database->setQuery( $query );
	if ( !$database->query() ) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$msg = $total ." Item(s) sent to the Trash";
	$return = mosGetParam( $_POST, 'returntask', '' );
	mosRedirect( "index2.php?option=$option&task=$return&sectionid=$sectionid", $msg );
}

/**
* Cancels an edit operation
* @param database A database connector object
*/
function cancelContent( $option ) {
	global $database;

	$redirect = mosGetParam( $_POST, 'redirect', $row->sectionid );

	$row = new mosContent( $database );
	$row->bind( $_POST );
	$row->checkin();
	mosRedirect( 'index2.php?option=com_content&sectionid='. $redirect );
}

/**
* Moves the order of a record
* @param integer The increment to reorder by
*/
function orderContent( $uid, $inc, $option ) {
	global $database;

	$row = new mosContent( $database );
	$row->load( $uid );
	$row->move( $inc, "catid='$row->catid' AND state >= 0" );

	$redirect = mosGetParam( $_POST, 'redirect', $row->sectionid );

	mosRedirect( 'index2.php?option='. $option .'&sectionid='. $redirect );
}

/**
* Form for moving item(s) to a different section and category
*/
function moveSection( $cid, $sectionid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to move'); window.history.go(-1);</script>\n";
		exit;
	}

	//seperate contentids
	$cids = implode( ',', $cid );
	// Content Items query
	$query = 	"SELECT a.title"
	. "\n FROM #__content AS a"
	. "\n WHERE ( a.id IN (". $cids .") )"
	. "\n ORDER BY a.title"
	;
	$database->setQuery( $query );
	$items = $database->loadObjectList();

	$database->setQuery(
	$query = 	"SELECT CONCAT_WS( ', ', s.id, c.id ) AS `value`, CONCAT_WS( '/', s.name, c.name ) AS `text`"
	. "\n FROM #__sections AS s"
	. "\n INNER JOIN #__categories AS c ON c.section = s.id"
	. "\n WHERE s.scope = 'content'"
	. "\n ORDER BY s.name, c.name"
	);
	$rows = $database->loadObjectList();
	// build the html select list
	$sectCatList = mosHTML::selectList( $rows, 'sectcat', 'class="inputbox" size="8"', 'value', 'text', null );

	HTML_content::moveSection( $cid, $sectCatList, $option, $sectionid, $items );
}

/**
* Save the changes to move item(s) to a different section and category
*/
function moveSectionSave( &$cid, $sectionid, $option ) {
	global $database, $my;

	$sectcat = mosGetParam( $_POST, 'sectcat', '' );
	list( $newsect, $newcat ) = explode( ',', $sectcat );

	if (!$newsect && !$newcat ) {
		mosRedirect( "index.php?option=com_content&sectionid=$sectionid&mosmsg=An error has occurred" );
	}

	// find section name
	$query = "SELECT a.name"
	. "\n FROM #__sections AS a"
	. "\n WHERE a.id = ". $newsect .""
	;
	$database->setQuery( $query );
	$section = $database->loadResult();

	// find category name
	$query = "SELECT  a.name"
	. "\n FROM #__categories AS a"
	. "\n WHERE a.id = ". $newcat .""
	;
	$database->setQuery( $query );
	$category = $database->loadResult();

	$total = count( $cid );
	$cids = implode( ',', $cid );

	$row = new mosContent( $database );
	// update old orders - put existing items in last place
	foreach ($cid as $id) {
		$row->load( intval( $id ) );
		$row->ordering = 9999;
		$row->store();
		$row->updateOrder( "catid='$row->catid' AND state >= 0" );
	}

	$query = "UPDATE #__content SET sectionid = '". $newsect ."', catid='". $newcat ."'"
	. "\n WHERE id IN ($cids)"
	. "\n AND ( checked_out='0' OR ( checked_out='". $my->id ."') )"
	;
	$database->setQuery( $query );
	if ( !$database->query() ) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	// update new orders - put items in last place
	foreach ($cid as $id) {
		$row->load( intval( $id ) );
		$row->ordering = 9999;
		$row->store();
		$row->updateOrder( "catid='$row->catid' AND state >= 0" );
	}

	$msg = $total. " Item(s) successfully moved to Section: ". $section .", Category: ". $category;
	mosRedirect( "index2.php?option=$option&sectionid=". $sectionid ."&mosmsg=". $msg );
}


/**
* Form for copying item(s)
**/
function copyItem( $cid, $sectionid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to move'); window.history.go(-1);</script>\n";
		exit;
	}

	//seperate contentids
	$cids = implode( ',', $cid );
	## Content Items query
	$query = 	"SELECT a.title"
	. "\n FROM #__content AS a"
	. "\n WHERE ( a.id IN (". $cids .") )"
	. "\n ORDER BY a.title"
	;
	$database->setQuery( $query );
	$items = $database->loadObjectList();

	## Section & Category query
	$query = 	"SELECT CONCAT_WS(',',s.id,c.id) AS `value`, CONCAT_WS(' // ', s.name, c.name) AS `text`"
	. "\n FROM #__sections AS s"
	. "\n INNER JOIN #__categories AS c ON c.section = s.id"
	. "\n WHERE s.scope='content'"
	. "\n ORDER BY s.name, c.name"
	;
	$database->setQuery( $query );
	$rows = $database->loadObjectList();
	// build the html select list
	$sectCatList = mosHTML::selectList( $rows, 'sectcat', 'class="inputbox" size="10"', 'value', 'text', NULL );

	HTML_content::copySection( $option, $cid, $sectCatList, $sectionid, $items );
}


/**
* saves Copies of items
**/
function copyItemSave( $cid, $sectionid, $option ) {
	global $database, $my;

	$sectcat = mosGetParam( $_POST, 'sectcat', '' );
	//seperate sections and categories from selection
	$sectcat = explode( ',', $sectcat );
	list( $newsect, $newcat ) = $sectcat;

	if ( !$newsect && !$newcat ) {
		mosRedirect( "index.php?option=com_content&sectionid=$sectionid&mosmsg=An error has occurred" );
	}

	// find section name
	$query = 	"SELECT a.name"
	. "\n FROM #__sections AS a"
	. "\n WHERE a.id = ". $newsect .""
	;
	$database->setQuery( $query );
	$section = $database->loadResult();

	// find category name
	$query = 	"SELECT  a.name"
	. "\n FROM #__categories AS a"
	. "\n WHERE a.id = ". $newcat .""
	;
	$database->setQuery( $query );
	$category = $database->loadResult();

	$total = count( $cid );
	for ( $i = 0; $i < $total; $i++ ) {
		$row = new mosContent( $database );

		// main query
		$query =	"SELECT a.* FROM mos_content AS a"
		. "\n WHERE a.id = ". $cid[$i] ."";
		;
		$database->setQuery( $query );
		$item = $database->loadObjectList();

		// values loaded into array set for store
		$row->id = NULL;
		$row->sectionid = $newsect;
		$row->catid = $newcat;
		$row->title = $item[0]->title;
		$row->title_alias = $item[0]->title_alias;
		$row->introtext = $item[0]->introtext;
		$row->fulltext = $item[0]->fulltext;
		$row->state = $item[0]->state;
		$row->mask = $item[0]->mask;
		$row->created = $item[0]->created;
		$row->created_by = $item[0]->created_by;
		$row->created_by_alias = $item[0]->created_by_alias;
		$row->modified = $item[0]->modified;
		$row->modified_by = $item[0]->modified_by;
		$row->checked_out = $item[0]->checked_out;
		$row->checked_out_time = $item[0]->checked_out_time;
		$row->frontpage_up = $item[0]->frontpage_up;
		$row->frontpage_down = $item[0]->frontpage_down;
		$row->publish_up = $item[0]->publish_up;
		$row->publish_down = $item[0]->publish_down;
		$row->images = $item[0]->images;
		$row->attribs = $item[0]->attribs;
		$row->version = $item[0]->parentid;
		$row->parentid = $item[0]->parentid;
		$row->ordering = $item[0]->ordering;
		$row->metakey = $item[0]->metakey;
		$row->metadesc = $item[0]->metadesc;
		$row->access = $item[0]->access;
		$row->hits = "0";

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
	}

	$msg = $total. " Item(s) successfully copied to Section: ". $section .", Category: ". $category;
	mosRedirect( "index2.php?option=". $option ."&sectionid=". $sectionid ."&mosmsg=". $msg ."" );
}

/**
* Function to reset Hit count of a content item
* PT
*/
function resethits() {
	global $database;
	$id = mosGetParam($_REQUEST,'id',null);

	$row = new mosContent($database);
	$row->Load($id);
	$row->hits = "0";
	$row->store();

	mosRedirect( 'index2.php?option=com_content&sectionid='. $row->sectionid,'Hits value reset to Zero on content item: '.$row->title );
}

/**
* Internal function to recursive scan the media manager directories
* @param string Path to scan
* @param string root path of this folder
* @param array  Value array of all existing folders
* @param array  Value array of all existing images
*/
function _readImages( $imagePath, $folderPath, &$folders, &$images ) {
	$imgFiles = mosReadDirectory( $imagePath );
	foreach ($imgFiles as $file) {
		if (is_dir( "$imagePath/$file" ) && $file!="CVS") {
			$folders[] = mosHTML::makeOption( "$folderPath$file/" );
			_readImages( "$imagePath/$file", $folderPath."$file/", $folders, $images );
		} else if (eregi( "bmp|gif|jpg|png", $file ) && is_file( "$imagePath/$file" )) {
			$imageFile = substr( "$folderPath$file", 1);			// leading / we don't need
			$images[$folderPath][] = mosHTML::makeOption( $imageFile, $file );
		}
	}
}

/**
* changes the access level of a record
* @param integer The increment to reorder by
*/
function accessMenu( $uid, $access, $option ) {
	global $database;

	$row = new mosContent( $database );
	$row->load( $uid );
	$row->access = $access;

	if ( !$row->check() ) {
		return $row->getError();
	}
	if ( !$row->store() ) {
		return $row->getError();
	}

	$redirect = mosGetParam( $_POST, 'redirect', $row->sectionid );

	mosRedirect( 'index2.php?option='. $option .'&sectionid='. $redirect );
}


?>
