<?php
/**
* @version $Id: language.class.php,v 1.8 2004/09/06 03:44:36 eddieajau Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
* @subpackage Installer
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
/**
* Language installer
* @package Mambo_4.5.1
*/
class mosInstallerLanguage extends mosInstaller {
	/**
	* Custom install method
	* @param boolean True if installing from directory
	*/
	function install( $p_fromdir = null ) {
		global $mosConfig_absolute_path,$database;

		if (!$this->preInstallCheck( $p_fromdir, 'language' )) {
			return false;
		}

		$xml = $this->xmlDoc();

		// Set some vars
		$e = &$xml->getElementsByPath( 'name', 1);
		$this->elementName($e->getText());
		$this->elementDir( mosPathName( $mosConfig_absolute_path . "/language/" ) );

		// Find files to copy
		if ($this->parseFiles( 'files', 'language' ) === false) {
		    return false;
		}
		if ($e = &$xml->getElementsByPath( 'description', 1 )) {
			$this->setError( 0, $this->elementName() . '<p>' . $e->getText() . '</p>' );
		}

		return $this->copySetupFile();
	}
	/**
	* Custom install method
	* @param int The id of the module
	* @param string The URL option
	* @param int The client id
	*/
	function uninstall( $id, $option, $client=0 ) {
		global $mosConfig_absolute_path;
	    $id = str_replace( array( '\\', '/' ), '', $id );
	    
	    if (trim( $id )) {
	        $file = $mosConfig_absolute_path . '/languages/' . $id . '.php';
	    	if (is_file( $file )) {
				return unlink( $file );
			} else {
				HTML_installer::showInstallMessage( 'Attemping to delete a directory', 'Uninstall -  error',
					$this->returnTo( $option, 'language', $client ) );
				exit();
			}
		} else {
			HTML_installer::showInstallMessage( 'Language id empty, cannot remove files', 'Uninstall -  error',
				$this->returnTo( $option, 'language', $client ) );
			exit();
		}

	}
/**
* return to method
*/
	function returnTo( $option, $element, $client ) {
		return "index2.php?option=com_languages";
	}

}
?>