<?php
/**
* @version $Id: index.php,v 1.32 2004/09/03 12:16:08 saka Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

if (file_exists( "../configuration.php" )) {
	header( "Location: ../index.php" );
	exit();
}
require_once ("../includes/version.php");

/** Include common.php */
include_once( "common.php" );

function get_php_setting($val) {
	$r =  (ini_get($val) == '1' ? 1 : 0);
	return $r ? 'ON' : 'OFF';
}

function writableCell( $folder ) {
	echo '<tr>';
	echo '<td class="item">' . $folder . '/</td>';
	echo '<td align="left">';
	echo is_writable( "../$folder" ) ? '<b><font color="green">Writeable</font></b>' : '<b><font color="red">Unwriteable</font></b>' . '</td>';
	echo '</tr>';
}
?>

<?php echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">"; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Mambo - Web Installer</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link rel="shortcut icon" href="../../images/favicon.ico" />
<link rel="stylesheet" href="install.css" type="text/css" />
<script>
var checkobj
function agreesubmit(el){
	checkobj=el
	if (document.all||document.getElementById){
		for (i=0;i<checkobj.form.length;i++){  //hunt down submit button
		var tempobj=checkobj.form.elements[i]
		if(tempobj.type.toLowerCase()=="submit")
		tempobj.disabled=!checkobj.checked
		}
	}
}

function defaultagree(el){
	if (!document.all&&!document.getElementById){
		if (window.checkobj&&checkobj.checked)
		return true
		else{
			alert("Please read/accept license to continue installation")
			return false
		}
	}
}

</script>
</head>
<body>

<div id="wrapper">
<div id="header">

<div id="mambo"><img src="header_install.png" alt="Mambo Installation" /></div>
</div>
</div>

<div id="ctr" align="center">
<div class="install">
<div id="stepbar">
<div class="step-on">pre-installation check</div>
<div class="step-off">license</div>
<div class="step-off">step 1</div>
<div class="step-off">step 2</div>
<div class="step-off">step 3</div>
<div class="step-off">step 4</div>
</div>
<div id="right">

<div id="step">pre-installation check</div>

<div class="far-right">
<input name="Button2" type="submit" class="button" value="Next >>" onclick="window.location='install.php';" />
</div>
<div class="clr"></div>

<h1>Pre-installation check for <?php echo $version; ?>:</h1>
<div class="install-text">
If any of these items are highlighted
in red then please take actions to correct them. Failure to do so
could lead to your Mambo installation not functioning
correctly.
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<tr>
	<td class="item">
	PHP version >= 4.1.0
	</td>
	<td align="left">
	<?php echo phpversion() < '4.1' ? '<b><font color="red">No</font></b>' : '<b><font color="green">Yes</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - zlib compression support
	</td>
	<td align="left">
	<?php echo extension_loaded('zlib') ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - XML support
	</td>
	<td align="left">
	<?php echo extension_loaded('xml') ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - MySQL support
	</td>
	<td align="left">
	<?php echo function_exists( 'mysql_connect' ) ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td valign="top" class="item">
	configuration.php
	</td>
	<td align="left">
	<?php echo is_writable( '..' ) ? '<b><font color="green">Writeable</font></b>' : '<b><font color="red">Unwriteable</font></b><br /><span class="small">You can still continue the install as the configuration will be displayed at the end, just copy & paste this and upload.</span>';?>
	</td>
</tr>
<tr>
	<td class="item">
	Session save path
	</td>
	<td align="left">
	<b><?php echo (($sp=ini_get('session.save_path'))?$sp:'Not set'); ?></b>,
	<?php echo is_writable( $sp ) ? '<b><font color="green">Writeable</font></b>' : '<b><font color="red">Unwriteable</font></b>';?>
	</td>
</tr>
</table>
</div>
</div>
<div class="clr"></div>

<h1>Recommended settings:</h1>
<div class="install-text">
These settings are recommended for PHP in order to ensure full
compatibility with Mambo.
<br/>
However, Mambo will still operate if your settings do not quite match the recommended
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<tr>
	<td class="toggle">
	Directive
	</td>
	<td class="toggle">
	Recommended
	</td>
	<td class="toggle">
	Actual
	</td>
</tr>
<tr>
	<td class="item">
	Safe Mode:
	</td>
	<td class="toggle">
	OFF
	</td>
	<td>
	<?php
	if ( get_php_setting('safe_mode') == 'OFF' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red"><b>
		<?php
	}
	echo get_php_setting('safe_mode');	?>
	</b></font>
	<td>
</tr>
<tr>
	<td class="item">
	Display Errors:
	</td>
	<td class="toggle">
	ON
	</td>
	<td>
	<?php
	if ( get_php_setting('display_errors') == 'ON' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('display_errors');?>
	</b></font>
	</td>
</tr>
<tr>
	<td class="item">
	File Uploads:
	</td>
	<td class="toggle">
	ON
	</td>
	<td>
	<?php
	if ( get_php_setting('file_uploads') == 'ON' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('file_uploads');?>
	</b></font>
	</td>
</tr>
<tr>
	<td class="item">
	Magic Quotes GPC:
	</td>
	<td class="toggle">
	ON
	</td>
	<td>
	<?php
	if ( get_php_setting('magic_quotes_gpc') == 'ON' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('magic_quotes_gpc');?>
	</b></font>
	</td>
</tr>
<tr>
        <td class="item">
        Magic Quotes Runtime:
        </td>
        <td class="toggle">
        OFF
        </td>
        <td>
        <?php
        if ( get_php_setting('magic_quotes_runtime') == 'OFF' ) {
                ?>
                <font color="green"><b>
                <?php
        } else {
                ?>
                <font color="red" style="bold"><b>
                <?php
        }
        echo get_php_setting('magic_quotes_runtime');?>
        </b></font>
        </td>
</tr>

<tr>
	<td class="item">
	Register Globals:
	</td>
	<td class="toggle">
	OFF
	</td>
	<td>
	<?php
	if ( get_php_setting('register_globals') == 'OFF' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('register_globals');?>
	</b></font>
	</td>
</tr>
<tr>
	<td class="item">
	Output Buffering:
	</td>
	<td class="toggle">
	OFF
	</td>
	<td>
	<?php
	if ( get_php_setting('output_buffering') == 'OFF' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('output_buffering');
	?>
	</b></font>
	</td>

</tr>
<tr>
	<td class="item">
	Session auto start:
	</td>
	<td class="toggle">
	OFF
	</td>
	<td>
	<?php
	if ( get_php_setting('session.auto_start') == 'OFF' ) {
		?>
		<font color="green"><b>
		<?php
	} else {
		?>
		<font color="red" style="bold"><b>
		<?php
	}
	echo get_php_setting('session.auto_start');?>
	</b></font>
	</td>
</tr>
</table>
</div>
</div>
<div class="clr"></div>

<h1>Directory and File Permissions:</h1>
<div class="install-text">
In order for Mambo to function
correctly it needs to be able to access or write to certain files
or directories. If you see "Unwriteable" you need to change the
permissions on the file or directory to allow Mambo
to write to it.
<div class="clr">&nbsp;&nbsp;</div>
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<?php
writableCell( 'administrator/backups' );
writableCell( 'administrator/components' );
writableCell( 'cache' );
writableCell( 'components' );
writableCell( 'images' );
writableCell( 'media' );
writableCell( 'language' );
writableCell( 'mambots/content' );
writableCell( 'mambots/search' );
writableCell( 'modules' );
writableCell( 'templates' );
?>
</table>
</div>
<div class="clr"></div>
</div>
<div class="clr"></div>
</div>
<div class="clr"></div>
</div>

<div class="ctr">
Miro International Pty Ltd.  2000 - 2004 All rights reserved.<br />
<a href="http://www.mamboserver.com" target="_blank">Mambo</a> is Free Software released under the GNU/GPL License.
</div>

</body>
</html>
