<?php
/**
* @version $Id: moscode.php,v 1.10 2004/08/26 10:51:48 eddieajau Exp $
* @package Mambo_4.5.1
* @copyright (C) 2000 - 2004 Miro International Pty Ltd
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Mambo is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onPrepareContent', 'botMosCode' );

/**
* Code Highlighting Mambot
*
* <b>Usage:</b>
* <code>{moscode}...some code...{/moscode}</code>
*/
function botMosCode( $published, &$row, &$params, $page=0 ) {
	global $mosConfig_absolute_path, $mosConfig_live_site;


	// override default colours to something a bit better
	//ini_set('highlight.html', '000000');
	//ini_set('highlight.default', '#800000');
	//ini_set('highlight.keyword','#0000ff');
	//ini_set('highlight.string', '#ff00ff');
	//ini_set('highlight.comment','#008000');

	// define the regular expression for the bot
	$regex = "#{moscode}(.*?){/moscode}#s";

	if (!$published) {
		$row->text = preg_replace( $regex, '', $row->text );
		return;
	}


	// perform the replacement
	$row->text = preg_replace_callback( $regex, 'botMosCode_replacer', $row->text );

	return true;
}
/**
* Replaces the matched tags an image
* @param array An array of matches (see preg_match_all)
* @return string
*/
function botMosCode_replacer( &$matches ) {
	$html_entities_match = array("#<#", "#>#");
	$html_entities_replace = array("&lt;", "&gt;");

	$after_replace = $matches[1];

	$after_replace = preg_replace($html_entities_match, $html_entities_replace, $after_replace);

	// Replace 2 spaces with "&nbsp; " so non-tabbed code indents without making huge long lines.
	$after_replace = str_replace("  ", "&nbsp; ", $after_replace);
	// now Replace 2 spaces with " &nbsp;" to catch odd #s of spaces.
	$after_replace = str_replace("  ", " &nbsp;", $after_replace);

	// Replace tabs with "&nbsp; &nbsp;" so tabbed code indents sorta right without making huge long lines.
	$after_replace = str_replace("\t", "&nbsp; &nbsp;", $after_replace);

	$replacement = $code_start_html;
	$after_replace = str_replace('&lt;', '<', $after_replace);
	$after_replace = str_replace('&gt;', '>', $after_replace);

	ob_start();
	highlight_string($after_replace);
	$after_replace = ob_get_contents();
	ob_end_clean();
	$replacement .= $after_replace;

	$text = str_replace($replacement, $text);

	$text = str_replace('&amp;nbsp;', '&nbsp;', $after_replace);
	$text = str_replace('&lt;br/&gt;', '<br />', $text);
	$text = str_replace('<font color="#007700">&lt;</font><font color="#0000BB">br</font><font color="#007700">/&gt;','<br />', $text);
	$text = str_replace('&amp;</font><font color="#0000CC">nbsp</font><font color="#006600">;', '&nbsp;', $text);
	$text = str_replace('&amp;</font><font color="#0000BB">nbsp</font><font color="#007700">;', '&nbsp;', $text);
	$text = str_replace('<font color="#007700">;&lt;</font><font color="#0000BB">br</font><font color="#007700">/&gt;','<br />', $text);

	return $text;
}
?>